# RestakedSwellLibrary

[Git Source](https://github.com/Ion-Protocol/ion-protocol/blob/88cc595825f1dc2eb738fb93e172a3e8ab7a5c43/src/libraries/lrt/RestakedSwellLibrary.sol)

A helper library for restaked Swell-related conversions.

### [Functions](https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/broken-reference) <a href="#functions" id="functions"></a>

#### [getEthAmountInForLstAmountOut](https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/broken-reference) <a href="#getethamountinforlstamountout" id="getethamountinforlstamountout"></a>

Returns the amount of ETH needed to mint the given amount of rswETH.

```
function getEthAmountInForLstAmountOut(IRswEth rswEth, uint256 lstAmount) internal view returns (uint256);
```

**Parameters**

| Name        | Type      | Description                   |
| ----------- | --------- | ----------------------------- |
| `rswEth`    | `IRswEth` | address.                      |
| `lstAmount` | `uint256` | Desired output amount. \[WAD] |

#### [getLstAmountOutForEthAmountIn](https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/broken-reference) <a href="#getlstamountoutforethamountin" id="getlstamountoutforethamountin"></a>

Returns the amount of ETH needed to mint the given amount of rswETH.

```
function getLstAmountOutForEthAmountIn(IRswEth rswEth, uint256 ethAmount) internal view returns (uint256);
```

**Parameters**

| Name        | Type      | Description                      |
| ----------- | --------- | -------------------------------- |
| `rswEth`    | `IRswEth` | address.                         |
| `ethAmount` | `uint256` | Amount of ETH to deposit. \[WAD] |

#### [depositForLrt](https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/broken-reference) <a href="#depositforlrt" id="depositforlrt"></a>

Deposits ETH into the rswETH contract and returns the amount of rswETH received.

```
function depositForLrt(IRswEth rswEth, uint256 ethAmount) internal returns (uint256);
```

**Parameters**

| Name        | Type      | Description                      |
| ----------- | --------- | -------------------------------- |
| `rswEth`    | `IRswEth` | address.                         |
| `ethAmount` | `uint256` | Amount of ETH to deposit. \[WAD] |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/restakedswelllibrary.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
